﻿; Peter Souza IV, 2019-09-17

;$OBFUSCATOR: $STRAIGHT_MODE:

;$OBFUSCATOR: $DEFGLOBVARS: gvMuteStyle, gvVolIncrement, gvBackgroundColor, gvBarColorMain, gvBarColorNotch, gvBarColorEmpty, gvTextColor, gvVolChanged, gvProgramName, gvVolumeTemp, gvVolume, gvVolBeforeMute, gvThemeSel, BarVal, BarValMid, BarLayerBottom, VolInfo
;$OBFUSCATOR: $DEFSYSFUNCS: Round, Mod, Floor
;$OBFUSCATOR: $DEFSYSVARS:  A_ScriptName, A_WinDir, A_Index

#MaxHotkeysPerInterval 1000000
#Warn,UseUnsetLocal,Off
#NoEnv
#SingleInstance force
SetBatchLines,-1
DetectHiddenWindows,On

IniRead,gvMuteStyle,BetterVolume.ini,General,MuteStyle,1
If ((gvMuteStyle <> 0) && (gvMuteStyle <> 1))
  gvMuteStyle=1
IniRead,gvVolIncrement,BetterVolume.ini,General,Increment,5
gvVolIncrement:=Round(gvVolIncrement)
If ((gvVolIncrement <= 0) || (gvVolIncrement > 25))
  gvVolIncrement=2
IniRead,gvThemeSel,BetterVolume.ini,Style,Theme,Default

IniRead,gvBackgroundColor,BetterVolume.ini,%gvThemeSel%Theme,BackgroundColor,000000
IniRead,gvBarColorMain,BetterVolume.ini,%gvThemeSel%Theme,BarColorMain,0061B0
IniRead,gvBarColorNotch,BetterVolume.ini,%gvThemeSel%Theme,BarColorNotch,FFFFFF
IniRead,gvBarColorEmpty,BetterVolume.ini,%gvThemeSel%Theme,BarColorEmpty,6A6A6A
IniRead,gvTextColor,BetterVolume.ini,%gvThemeSel%Theme,TextColor,FFFFFF


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                  ;;
;;       Do not change anything from here on!       ;;
;;                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


gvVolChanged:=false
gvProgramName:=A_ScriptName
StringTrimRight,gvProgramName,gvProgramName,4 ; remove .ahk or .exe
SoundGet,gvVolume
gvVolumeTemp:=Round(Round(gvVolume/gvVolIncrement)*gvVolIncrement) ; Force existing volume to be within increment
If ((gvVolumeTemp == 0) && (gvVolume > 0))
  gvVolumeTemp:=gvVolIncrement
gvVolume:=gvVolumeTemp
SoundSet,% gvVolume
SoundGet,gvVolBeforeMute
gvVolume:=Round(gvVolume)
SetTrayIconVolume(gvVolume)

Gui,+ToolWindow +AlwaysOnTop -SysMenu -Caption -DPIScale +E0x08000000 +hwndhWndAhkGUI +LastFound ; WS_EX_NOACTIVATE, See https://msdn.microsoft.com/en-us/library/windows/desktop/ff700543(v=vs.85).aspx
Gui,Color,% gvBackgroundColor
Gui,Show,W65 H140 X50 Y60 Hide

Gui,Add,Progress,w13 h91 x25 y15 vBarVal Vertical hwndhWndProgBar C%gvBarColorMain% Range=0-115 Background886600
WinSet, TransColor, 886600, ahk_id %hWndProgBar%
GuiControl, -Border, BarVal
Control ExStyle, -0x20301, , ahk_id %hWndProgBar%

Gui,Add,Progress,w13 h91 x25 y15 vBarValMid Vertical hwndhWndProgBarMid Range=0-115 C%gvBarColorNotch% Background886633
WinSet, TransColor, 886633, ahk_id %hWndProgBarMid%
GuiControl,,BarValMid,110

Gui,Add,Progress,w13 h91 x25 y15 vBarLayerBottom Vertical hwndhWndProgBarBottom C%gvBarColorEmpty% Background%gvBackgroundColor%
GuiControl,,BarLayerBottom,100

Gui, Font, s10
Gui, Font, s10, Segoe UI
Gui,Add,Text, w81 x-9 y110 vVolInfo Center -Border C%gvTextColor% Background%gvBackgroundColor%

Gui,Hide
Return ; end auto-execute
;$OBFUSCATOR: $END_AUTOEXECUTE:


;; Macro 'Mute' key
Volume_Mute::
ToggleMute()
Return


;; Macro 'Volume Up' key
Volume_Up::
VolumeSetTrigger(gvVolIncrement)
Return


;; Macro 'Volume Down' key
Volume_Down::
VolumeSetTrigger(-gvVolIncrement)
Return


;; Timer label to fade out the GUI
SliderOff:
FadeOutWindow(hWndAhkGUI)
Return


;; GoSub label to display the GUI (lots of globals here, easier as a global label than function)
DisplaySlider:
SoundGet,gvVolume
gvVolume:=Round(gvVolume)
SetTrayIconVolume(gvVolume)
VolumeMid:=Round(gvVolume+15)
Title:=gvProgramName . hidestr("     Current Volume=") . gvVolume
Gui,Show,NoActivate,% Title
WinSet,Transparent,Off,ahk_id %hWndAhkGUI%
;WinSet,Transparent,220,ahk_id %hWndAhkGUI%
;WinSet,TransColor,Off,ahk_id %hWndAhkGUI%
;WinSet,TransColor,%gvBackgroundColor% 220,ahk_id %hWndAhkGUI%
GuiControl,,BarVal,% gvVolume
If (gvVolume > 0)
  GuiControl,,VolInfo,% gvVolume
Else
  GuiControl,,VolInfo,❌
GuiControl,,BarValMid,% VolumeMid
Return


ToggleMute()
{
  ;$OBFUSCATOR: $DEFLOSVARS: IsMutedCheck
  global gvVolChanged
  global gvVolBeforeMute
  gvVolChanged:=true
  SoundGet,IsMutedCheck
  IsMutedCheck:=Round(IsMutedCheck)
  If (IsMutedCheck > 0)
  {
    SoundGet,gvVolBeforeMute
    SoundSet,0
  }
  Else
    SoundSet,% gvVolBeforeMute
  SetTimer,SliderOff,-1600
  Gosub,DisplaySlider
}


Unmute()
{
  ;$OBFUSCATOR: $DEFLOSVARS: IsMutedCheck
  global gvVolBeforeMute
  SoundGet,IsMutedCheck
  IsMutedCheck:=Round(IsMutedCheck)
  If (IsMutedCheck == 0)
    SoundSet,% gvVolBeforeMute
}


VolumeSetTrigger(val)
{
  ;$OBFUSCATOR: $DEFLOSVARS: CurLocalVolume
  global gvVolChanged
  global gvVolBeforeMute
  gvVolBeforeMute=0
  gvVolChanged:=true
  Unmute()
  SoundGet,CurLocalVolume
  CurLocalVolume:=Round(val+CurLocalVolume)
  if (val == 0)
    SoundSet,0
  else
    SoundSet,% CurLocalVolume
  SetTimer,SliderOff,-1600
  GoSub,DisplaySlider
}


;FadeInWindow(hWnd)
;{
;  WinSet,Transparent,0,ahk_id %hWnd%
;  Gui,Show,NoActivate
;
;  Loop,255
;  {
;    if(!Mod(A_Index+1,5))
;    {
;      WinSet,Transparent,%A_Index%,ahk_id %hWnd%
;      Sleep,2
;    }
;  }
;  WinSet,Transparent,Off,ahk_id %hWnd%
;}


FadeOutWindow(hWnd)
{
  ;$OBFUSCATOR: $DEFLOSVARS: NewVal
  global gvVolChanged
  gvVolChanged := false
  WinSet,Transparent,255,ahk_id %hWnd%
  Gui,Show,NoActivate

  Loop,255
  {
    If (gvVolChanged)
    {
      WinSet,Transparent,255,ahk_id %hWnd%
      Return
    }
    If (!Mod(A_Index+1,5))
    {
      NewVal := (255 - A_Index)
      WinSet,Transparent,%NewVal%,ahk_id %hWnd%
      Sleep,2
    }
  }
  WinSet,Transparent,Off,ahk_id %hWnd%
  Gui,Hide
  gvVolChanged:=false
}


SetTrayIconVolume(volLevel)
{
  ;$OBFUSCATOR: $DEFLOSVARS: TrayIconFile, TrayIconNum

  ;TrayIconFile:=A_WinDir . "\System32\DDORes.dll" ; get tray icon from DDORes.dll
  ;TrayIconNum:="-2011" ; use headphones as tray icon (icon 2032 in DDORes)

  global gvMuteStyle
  TrayIconFile:=A_WinDir . hidestr("\System32\SndVolSSO.dll")
  If (volLevel < 1)
  {
    If (gvMuteStyle = 0)
      TrayIconNum:=hidestr("-120")
    Else
      TrayIconNum:=hidestr("-121")
  }
  Else If (volLevel <= 33)
    TrayIconNum:=hidestr("-122")
  Else If (volLevel <= 67)
    TrayIconNum:=hidestr("-123")
  Else
    TrayIconNum:=hidestr("-124")
  Menu,Tray,Icon,%TrayIconFile%,%TrayIconNum%
  TrayTip:=hidestr("Speakers: ") . volLevel
  Menu,Tray,Tip,% TrayTip
}


hidestr(thisstr)
{
  Return thisstr
}


decode_hidestr(startstr) 
{
	global	
;$OBFUSCATOR: $DEFGLOBVARS: hexdigits
	critical
	static newstr, startstrlen, charnum, hinibble, lownibble, mybinary
;$OBFUSCATOR: $DEFLOSVARS: newstr, startstrlen, charnum, hinibble, lownibble, mybinary

	hexdigits = % "0123456789abcdef"
		
	decode_hexshiftkeys(startstr)
	
	startstr = % substr(startstr, 1, 1) . substr(startstr, 6)
	startstrlen = % strlen(startstr)
		
	newstr = 
	loop, % strlen(startstr) 
		newstr = % substr(startstr, a_index, 1) . newstr
	
	startstr = % newstr
	newstr = 
	charnum = 1
	loop
	{
		if (charnum >startstrlen)
			break
			
		hinibble = % substr(startstr, charnum, 1)
		hinibble = % instr(hexdigits, hinibble) - 1
		
		lownibble = % substr(startstr, charnum + 1, 1)
		lownibble = % instr(hexdigits, lownibble) - 1
		
		hinibble := decode_shifthexdigit(hinibble)
		lownibble := decode_shifthexdigit(lownibble)
		
		mybinary = % hinibble * 16 + lownibble
		newstr .= chr(mybinary)
		
		charnum += 2		
	}
		
	newstr = % fixescapes(newstr)
		
	return, newstr	
}


decode_hexshiftkeys(startstr)
{
	global
;$OBFUSCATOR: $DEFGLOBVARS: decodekey, ishexchar, useshiftkey
	
	decodekey := "fff@kkf1ffkfkfkfff#k1fk@kf#@fffk@#kk"
	ishexchar := "fff@f1ff@kffkk#f1fffffkf"
	
	%decodekey%%ishexchar%1 = % substr(startstr, 2, 1)
	%decodekey%%ishexchar%2 = % substr(startstr, 3, 1)
	%decodekey%%ishexchar%3 = % substr(startstr, 4, 1)
	%decodekey%%ishexchar%4 = % substr(startstr, 5, 1)
	
	loop, 4
		%decodekey%%a_index% = % instr(hexdigits, %decodekey%%ishexchar%%a_index%) - 1
			
	useshiftkey = 0
}	


decode_shifthexdigit(hexvalue)
{
	global
	
	useshiftkey++
	if (useshiftkey > 4)
		useshiftkey = 1	
	
	hexvalue -= %decodekey%%useshiftkey%
	
	if (hexvalue < 0) 
		hexvalue += 16
		
	return hexvalue	
}


fixescapes(forstr)
{
	global
	
	StringReplace, forstr, forstr, % "````", % "``", all
	StringReplace, forstr, forstr, % "``n", % "`n", all
	StringReplace, forstr, forstr, % "``r", % "`r", all
	StringReplace, forstr, forstr, % "``,", % "`,", all
	StringReplace, forstr, forstr, % "``%", % "`%", all	
	StringReplace, forstr, forstr, % "``;", % "`;", all	
	StringReplace, forstr, forstr, % "``t", % "`t", all
	StringReplace, forstr, forstr, % "``b", % "`b", all
	StringReplace, forstr, forstr, % "``v", % "`v", all
	StringReplace, forstr, forstr, % "``a", % "`a", all
	
	StringReplace, forstr, forstr, % """""", % """", all
	
	return forstr
}
